<template>
  <el-row :gutter="0" class="row recommendation">
    <el-col class="col-5 --none">
      <GChart
        v-loading="loading"
        type="PieChart"
        :data="chartData"
        :options="chartOptions"
        :resizeDebounce="500"
        :key="rerender"
        @ready="onChartReady"
      />
      <div class="forced-title">
        <div class="percent">{{ Math.round(getPercentageValue(recommendationReport[idx].percentage)) }} %</div>
        <div class="total">{{ recommendationReport[idx].count }} <svg-icon icon-class="people-dark-green" /></div>
      </div>
    </el-col>
    <el-col class="col-5" v-for="(item, index) in getRecommendationData()" :key="index" >
      <el-row :gutter="40" class="mid">
        <el-col :xs="12" :sm="12" :lg="6" class="padd-icon-left">
          <div class="icon-green">
            <svg-icon icon-class="info" class-name="card-panel-icon" />
          </div>
        </el-col>
        <el-col :xs="12" :sm="12" :lg="18" class="padd-icon-right">
          <div class="card-panel-text-black">{{ item.category  }}</div>
        </el-col>
      </el-row>
      <div class="progress progress-padd">
        <transition appear>
          <el-progress :text-inside="true" :stroke-width="35" :percentage="getPercentageValue(item.percentage)"></el-progress>
        </transition>
        <div class="farmer-count farmer-count--percent">{{ getPercentageValue(item.percentage) }} %</div>
        <div class="farmer-count farmer-count--decimal">
          {{ item.count }}
          <svg-icon icon-class="people-dark-green" />
        </div>
      </div>
    </el-col>
  </el-row>
</template>
<script>
import { GChart } from 'vue-google-charts';
export default {
  name: 'Activity',
  components: {
    GChart
  },
  props: ['color', 'idx'],
  data() {
    return {
      chartData: null,
      loading: true,
      rerender: 0,
      chartOptions: {
        chart: {
          title: 'Farmer chart by gender',
          subtitle: 'Jenis kelamin'
        },
        animation: {
          duration: 1200,
          easing: 'out',
          startup: true
        },
        height: 250,
        pieHole: 0.65,
        pieSliceText: 'none',
        slices: [
          { color: this.color },
          { color: '#c2d6b5' }
        ],
        legend: {
          position: 'none',
          align: 'left',
          textStyle: {
            color: { color: '#373737' },
            fontName: 'Nunito',
            fontSize: 18,
            bold: 1
          }
        },
        tooltip: {
          ignoreBounds: true,
          isHtml: true,
          trigger: 'none'
        }
      }
    };
  },
  computed: {
    recommendationReport: {
      get: function() {
        return this.$store.state.recommendation.recommendationReport
      }
    }
  },
  methods: {
    getRecommendationData: function() {
      if (this.recommendationReport == null) {
        return [];
      }
      return this.recommendationReport[this.idx].data;
    },
    getPercentageValue: function(percent_str) {
      if (typeof percent_str === 'undefined') {
        return 0.0;
      }
      return parseFloat(percent_str);
    },
    getTotalRecommendation: function() {
      var total = 0;
      if (this.recommendationReport == null) {
        return 0;
      }
      for (let i = 0; i < this.recommendationReport.length; i++) {
        total = total + this.recommendationReport[i].count;
      }
      return total;
    },
    onChartReady(chart, google) {
      this.loading = true;
      this.createDataTable(chart, google);
      setTimeout(() => {
        this.loading = false;
      }, 1.5 * 1000);
    },
    createDataTable(chart, google) {
      // if (this.recommendationReport == null) {
      //   return;
      // }
      const dataArray = [];
      dataArray.push([this.recommendationReport[this.idx].name, this.recommendationReport[this.idx].count]);
      dataArray.push(["none", this.getTotalRecommendation() - this.recommendationReport[this.idx].count]);
      const total = getTotal(dataArray);

      for (let i = 0; i < dataArray.length; i++) {
        dataArray[i].push(customTooltip(dataArray[i][0], dataArray[i][1], total));
      }

      // Changing legend
      for (let i = 0; i < dataArray.length; i++) {
        dataArray[i][0] =
          dataArray[i][0] + ' ' + ((dataArray[i][1] / total) * 100).toFixed(1) + '% ' + dataArray[i][1] + ` Petani`;
      }

      // Column names
      dataArray.unshift(['Location', 'Percentage', 'Tooltip']);

      const dataTable = google.visualization.arrayToDataTable(dataArray);
      dataTable.setColumnProperty(2, 'role', 'tooltip');
      dataTable.setColumnProperty(2, 'html', true);
      dataTable.setColumnProperty(0, 'className', 'jajal');

      function customTooltip(name, value, total) {
        return (
          '<div class="location-tooltip">' +
          '<table class="location-tooltip__box"><tr><td><b>' +
          name +
          '<br/></b></td></tr><tr><td><b>' +
          value +
          '</b><span><img src="https://user-core.s3-ap-southeast-1.amazonaws.com/assets/people-dark-green.svg" /></span></td><td><span><b>(' +
          ((value / total) * 100).toFixed(1) +
          '%)</b></span></td></tr></table></div>'
        );
      }

      function getTotal(dataArray) {
        let total = 0;
        for (let i = 0; i < dataArray.length; i++) {
          total += dataArray[i][1];
        }
        return total;
      }
      this.chartData = dataTable;
      chart.draw(dataTable, this.chartOptions);
    }
  }
};
</script>
<style rel="stylesheet/scss" lang="scss" >
@import '@/styles/variables.scss';
@import '@/styles/mixin.scss';

.icon-green {
  width: 48px;
  height: 48px;
  border-radius: 6px;
  background-color: #76be40;
  display: flex;
  justify-content: center;
  align-items: center;

  .svg-icon {
    width: 30px;
    height: 30px;
  }
}

.farmer-count {
  display: inline-block;
  color: $ritx-dark-green;
  font-weight: 600;
  margin-top: 10px;
  &--decimal {
    float: right;
  }
}

.row-info {
  background-color: #d2d9cd8c;
  padding: 7px 20px;
  opacity: 0.6;
}

.row-mid {
  background-color: #d2e0c65c;
}

.row-info-percentage {
  color: #086939;
  font-size: 12px;
  font-weight: bold;
  display: inline-block;
  width: 30%;
  text-align: right;
}
.row-info-text {
  color: #373737;
  font-size: 12px;
  display: inline-block;
  width: 65%;
}
.mid {
  display: flex;
  align-items: center;
}
.progress {
  margin: 10px 0 16px 0;
}
.col-5 {
  width: 20%;
  border-right: 1px solid $ritx-light-grey-3;
  &.\-\-none {
    border-right: none;
    position: relative;
  }
}
.row {
  margin: 0 -16px;
}
.recommendation {
  height: 300px;
  display: flex;
  align-items: center;
  overflow: hidden;
}
.pad, .progress-padd {
  padding: 0 20px;
}

.padd-icon-left {
  padding-left: 40px!important;
}
.padd-icon-right {
  padding-right: 40px!important;
}

.forced-title {
  position: absolute;
  margin: auto;
  left: 0;
  right: 0;
  top: 0;
  bottom: 0;
  z-index: 100;
  width: 80px;
  height: 50px;
  background: white;
  text-align: center;

  .percent {
    color: #086939;
    font-size: 24px;
    font-weight: bold;
  }

  .total {
    color: #086939;
    font-size: 16px;
    font-weight: normal;
  }
}
</style>
